<?php

namespace Drupal\entity_theme_engine\Normalizer;


use Drupal\file\Entity\File;

class ImageItemNormalizer extends FieldItemNormalizer {

  /**
   * The interface or class that this Normalizer supports.
   *
   * @var string
   */
  protected $supportedInterfaceOrClass = ['Drupal\image\Plugin\Field\FieldType\ImageItem', 'Drupal\multiversion\ImageItem'];

  /**
   * {@inheritdoc}
   */
  public function normalize($field, $format = NULL, array $context = []) {
    $data = parent::normalize($field, $format, $context);
    $data['styles'] = $this->getImageStylesVariables($field->entity);
    return $data;
  }
  
  public static function getImageStylesVariables(File $entity) {
    $variables = [];
    $styles = static::getStyles();
    foreach ($styles as $id => $style) {
      $variables[$id] = $style->buildUrl($entity->getFileUri());
    }
    return $variables;
  }
  public static function getStyles() {
    $cache = &drupal_static(__METHOD__, []);
    if(empty($cache)) {
      $cache = \Drupal::entityTypeManager()->getStorage('image_style')->loadMultiple();
    }
    return $cache;
  }

}
