<?php

namespace Drupal\entity_theme_engine\Normalizer;


use Drupal\views\Views;

class ViewsItemNormalizer extends FieldItemNormalizer {

  /**
   * The interface or class that this Normalizer supports.
   *
   * @var string
   */
  protected $supportedInterfaceOrClass = ['Drupal\viewsreference\Plugin\Field\FieldType\ViewsReferenceItem'];

  /**
   * {@inheritdoc}
   */
  public function normalize($field, $format = NULL, array $context = []) {
    $data = parent::normalize($field, $format, $context);
    $view_name = $field->target_id;
    $display_id = $field->display_id;
    $options = unserialize($field->data);
    $view = Views::getView($view_name);
    $view->setDisplay($display_id);
    
    $view->element['#viewsreference'] = [
      'data' => $options,
      'enabled_settings' => array_keys(array_filter($options)),
    ];
    
    $view->preExecute();
    $view->execute($display_id);
    
    $render = $view->preview();
    $data['render'] = \Drupal::service('renderer')->renderRoot($render['#rows']);
    
    return $data;
  }
}
